import java.awt.*;
import java.util.*;

public class Hero{
  private Image image;
  private Canvas canvas;
  private int deltaX=1,deltaY=1;
  private int x,y;
  public Hero(Image img,Canvas c){
    image=img;
    canvas=c;
    Timer timer=new Timer();
    TimerTask task=new TimerTask(){
      public void run(){
        move();
      }
    };
    timer.schedule(task,new Date(),100);
  }
  private void move(){
    x+=deltaX;
    y+=deltaY;
    if(hasInside()){
      draw();
    }else{
      nextDirection();
    }
  }
  private void draw(){
    Graphics g=canvas.getGraphics();
    g.setColor(Color.WHITE);
    g.fillRect(0,0,getCanvasWidth(),getCanvasHeight());
    g.drawImage(image,x,y,canvas);
  }
  private void nextDirection(){
    if(x<0){
      deltaX=1;
    }else if(y<0){
      deltaY=1;
    }else if(x>getCanvasWidth()-getWidth()){
      deltaX=-1;
    }else if(y>getCanvasHeight()-getHeight()){
      deltaY=-1;
    }
  }
  private boolean hasInside(){
    return getCanvasBounds().contains(getBounds());
  }
  private int getWidth(){
    return (int)getBounds().getWidth();
  }
  private int getHeight(){
    return (int)getBounds().getHeight();
  }
  private Rectangle getBounds(){
    return new Rectangle(x,y,image.getWidth(canvas),image.getHeight(canvas));
  }
  private int getCanvasWidth(){
    return (int)getCanvasBounds().getWidth();
  }
  private int getCanvasHeight(){
    return (int)getCanvasBounds().getHeight();
  }
  private Rectangle getCanvasBounds(){
    return canvas.getBounds();
  }
}